#include<iostream>

using namespace std;

string s;
int k,n;
int segmentTree[4000001];

void init(int ind,int l,int r)
{
    if(l==r)
    {
        segmentTree[ind]=l-1;
        //cout<<ind<<" "<<segmentTree[ind]<<endl;
        return;
    }
    int mid=(l+r)/2;

    init(2*ind,l,mid);
    init(2*ind+1,mid+1,r);

    if(s[segmentTree[2*ind]]>=s[segmentTree[2*ind+1]])
        segmentTree[ind]=segmentTree[2*ind];
    else
        segmentTree[ind]=segmentTree[2*ind+1];

    //cout<<ind<<" "<<segmentTree[ind]<<endl;

    return;
}

void update(int ind,int l,int r,int Search,char value)
{
    if(l>Search || r<Search)return;
    if(l==r)
    {
        s[l-1]=value;
        return;
    }

    int mid=(l+r)/2;

    update(2*ind,l,mid,Search,value);
    update(2*ind+1,mid+1,r,Search,value);

    if(s[segmentTree[2*ind]]>=s[segmentTree[2*ind+1]])
        segmentTree[ind]=segmentTree[2*ind];
    else
        segmentTree[ind]=segmentTree[2*ind+1];

    //cout<<segmentTree[ind]<<endl;

    return;
}

int query(int ind,int l,int r,int sl,int sr)
{
    //cout<<ind<<" "<<l<<" "<<r<<" "<<sl<<" "<<sr<<endl;
    //cout<<segmentTree[ind]<<endl;

    if(l>sr || r<sl)
        return n;
    if(sl<=l && sr>=r)
        return segmentTree[ind];

    int mid=(l+r)/2;
    int q1,q2;

    q1=query(2*ind,l,mid,sl,sr);
    q2=query(2*ind+1,mid+1,r,sl,sr);

    if(s[q1]>=s[q2])
        return q1;

    return q2;
}

int main ()
{
    int i,q;

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>s>>k;

    n=s.size();
    s+=(char)0;

    init(1,1,n);

    for(i=1;i<=n-k;i++)
    {
        q=query(1,1,n,1,k+i);
        //cout<<q<<endl;
        cout<<s[q];
        //cout<<q+1<<endl;
        update(1,1,n,q+1,(char)0);
    }

    cout<<endl;

    return 0;
}
