#include<iostream>
#include<map>

using namespace std;

struct rational
{
    long long p,q;
};

rational make_L_rational(string L)
{
    long long cnt=L.size(),i;
    rational r;
    r.p=0;
    r.q=1;

    for(i=0;i<cnt;i++)
    {
        if(L[i]!='0')break;
    }
    if(i==cnt)
        i--;
    for(i;i<cnt;i++)
    {
        r.p=(long long)(L[i]-'0')+r.p*10;
    }

    return r;
}

rational make_F_rational(string F)
{
    rational r;
    long long i,cnt=F.size();

    r.p=0;
    r.q=1;

    for(i=0;i<cnt;i++)
    {
        r.p=(long long)(F[i]-'0')+r.p*10;
        r.q*=10;
    }

    return r;
}

long long gcd(long long a,long long b)
{
    if(b==0)
        return a;

    return gcd(b,a%b);
}


rational make_P_rational(string P)
{
    rational r;
    long long i,cnt=P.size(),tmp;

    if(P=="")
    {
        r.p=0;
        r.q=1;
        return r;
    }

    r.p=0;
    r.q=1;

    for(i=0;i<cnt;i++)
    {
        r.p=(long long)(P[i]-'0')+r.p*10;
        r.q*=10;
    }


    r.q--;

    tmp=gcd(r.p,r.q);

    r.q/=tmp;
    r.p/=tmp;

    return r;
}


rational add(rational r1,rational r2)
{
    rational res;
    long long g;

    g=gcd(r1.q,r2.q);
    //cout<<g<<endl;

    res.q=r1.q*r2.q/g;
    res.p=r1.p*(r2.q/g)+r2.p*(r1.q/g);

    g=gcd(res.q,res.p);
    res.q/=g;
    res.p/=g;

    return res;
}

rational make_rational(string a)
{
    long long i,cnt=a.size(),dotInd,bracketInd;
    bool dot=0,bracket=0;
    string L,F,P;
    rational res,r1,r2,r3;

    for(i=0;i<cnt;i++)
    {
        if(a[i]=='.')
        {
            dot=true;
            dotInd=i;
        }
        if(a[i]=='(')
        {
            bracket=true;
            bracketInd=i;
        }
    }

    L=a;
    if(dot)
        L.erase(dotInd,cnt-dotInd);

    if(dot)
    {
        if(bracket)
        {
            if(bracketInd!=dotInd+1)
            {
                F=a;
                F.erase(0,dotInd+1);
                F.erase(bracketInd-dotInd-1,cnt-bracketInd);
            }
            P=a;
            P.erase(P.size()-1,1);
            P.erase(0,bracketInd+1);
        }
        else
        {
            F=a;
            F.erase(0,dotInd+1);
        }
    }

    //cout<<make_P_rational(P).p<<" "<<make_P_rational(P).q<<endl;

    r1=make_L_rational(L);
    r2=make_F_rational(F);
    r3=make_P_rational(P);

    r3.q*=r2.q;

    res=add(add(r1,r2),r3);

    //cout<<L<<endl;
    //cout<<F<<endl;
    //cout<<P<<endl;

    return res;
}

map<long long,long long> remainder;

void output(rational r)
{
    //cout<<r.p<<" "<<r.q<<endl;
    cout<<r.p/r.q;
    if(r.p%r.q==0)
        return;

    string s=".";
    long long i=1;

    r.p%=r.q;
    r.p*=10;


    while(true)
    {
        //cout<<r.p<<" "<<r.q<<endl;
        if(r.p%r.q==0)
        {
            cout<<s;
            return;
        }
        if(remainder[r.p%r.q])
        {
            break;
        }
        remainder[r.p%r.q]=i;
        //cout<<i<<endl;
        i++;
        s+=(char)(r.p/r.q)+'0';
        r.p%=r.q;
        r.p*=10;
    }
    s+=(char)(r.p/r.q)+'0';
    s+=")";
    s.insert(remainder[r.p%r.q+1],"(");
    cout<<s;
}

int main ()
{
    string a,b;
    rational r1,r2;

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>a>>b;

    r1=make_rational(a);
    r2=make_rational(b);

    //cout<<r1.p<<" "<<r1.q<<endl;

    r1=add(r1,r2);

   // cout<<r1.p<<""<<r1.q<<endl;

    output(r1);

    cout<<endl;

    return 0;
}
/*
0073.5203(703)
0.(30891)
*/
